/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#include <src/investigation/donnees/arbreinvestigation.h>

using namespace Investigation::Donnees;


void ArbreInvestigation::liens_inverses(std::map<Identifiant,std::map<LienPage,size_t> >& liens) const
{
	auto source_liens = _site->pages_actives_source();
	for(auto it=_fils.cbegin() ; it!=_fils.cend() ; ++it)
	{
		auto destination_liens = it->second->_site->pages_actives_destination();
		auto pages_source = source_liens._identifiants_pages_actives.find(it->first);
		auto pages_destination = destination_liens._identifiants_pages_actives.find(it->first);
		if((pages_source!=source_liens._identifiants_pages_actives.end()) and (pages_destination!=destination_liens._identifiants_pages_actives.end()))
		{
			for(auto it_destination=pages_destination->second.cbegin() ; it_destination!=pages_destination->second.cend() ; ++it_destination)
			{
				for(auto it_source=pages_source->second.cbegin() ; it_source!=pages_source->second.cend() ; ++it_source)
				{
					auto it_liens = liens.find(*it_destination);
					if(it_liens==liens.end())
					{
						it_liens = (liens.insert(std::make_pair(*it_destination,std::map<LienPage,size_t>()))).first;
					}
					LienPage lien_page(*it_source,it->first);
					auto it_lienspage = it_liens->second.find(lien_page);
					if(it_lienspage==it_liens->second.end())
					{
						it_lienspage = ((it_liens->second).insert(std::make_pair(lien_page,0))).first;
					}
					++(it_lienspage->second);
				}
			}
		}
		it->second->liens_inverses(liens);
	}
}
