/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#include <src/investigation/donnees/identifiants.h>

using namespace Investigation::Donnees;

void IdentifiantPagesActives::operator+=(const IdentifiantPagesActives& identifiants_pages_actives)
{
	for(auto it=identifiants_pages_actives._identifiants_pages_actives.cbegin() ; it!=identifiants_pages_actives._identifiants_pages_actives.cend() ; ++it)
	{
		auto itf=_identifiants_pages_actives.find(it->first);
		if(itf==_identifiants_pages_actives.end())
		{
			_identifiants_pages_actives[it->first] = it->second;
		}
		else
		{
			itf->second.insert(it->second.cbegin(), it->second.cend());
		}
	}
}

IdentifiantPagesActives::IdentifiantPagesActives(const std::string& mot_clef, const Identifiant& identifiant)
{
	std::set<Identifiant> id;
	id.insert(identifiant);
	_identifiants_pages_actives.insert(std::make_pair(mot_clef,id));
}
